<template>
    <div>
       <div class="flex justify-center mt-[50px]">
        <div>
          <div v-if="pagesNumbers > 1"  class="flex gap-2 justify-center mt-[50px]">
            <button v-show="currentPage > 1" @click="toPreviousPage" class="text-[30px] select-none">←</button>
            <p class="text-[20px] cursor-pointer select-none py-[5px] px-[15px]" v-for="page in paginationView" :class="page === props.currentPage && 'text-red-500 text-center border-2 border-[#A16CF6] text-[white] bg-[#A16CF6] rounded-[8px]' || Number.isInteger(page) && 'text-center border-2 rounded-[8px]' || page === '...' && 'font-bold text-[30px]'" @click="goToPage(page)" :key="page">{{page}}</p>
            <button  v-show="currentPage < pagesNumbers" @click="toNextPage" class="text-[30px] select-none">→</button>
          </div>
        </div>
    </div>
    </div>

</template>

<script setup>
import { computed } from 'vue'
const props = defineProps({
  totalCount: {
    type: Number,
    required: true
  },
  perPage: {
    type: Number,
    required: true
  },
  currentPage: {
    type: Number,
    required: true
  }

})

const pagesNumbers = computed(() => {
  return Math.ceil(props.totalCount / props.perPage)
})

const emit = defineEmits({ 'update-pagination': null })

const goToPage = (page) => {
  if (page !== '...') {
    emit('update-pagination', page)
  }
}

const toPreviousPage = () => {
  if (props.currentPage !== 1) {
    emit('update-pagination', props.currentPage - 1)
  }
}
const toNextPage = () => {
  if (props.currentPage !== pagesNumbers.value) {
    emit('update-pagination', props.currentPage + 1)
  }
}

const paginationNumbers = computed(() => {
  const pagesArr = []
  for (let i = 1; i <= pagesNumbers.value; i++) {
    pagesArr.push(i)
  }
  return pagesArr
})

const paginationView = computed(() => {
  if (pagesNumbers.value > 9) {
    const firstThreePages = paginationNumbers.value.slice(0, 3)
    const lastThreePages = paginationNumbers.value.slice(paginationNumbers.value.length - 3)
    const pagesArr = []
    const beforePages = props.currentPage - 1
    const afterPages = props.currentPage + 1

    pagesArr.push(...firstThreePages)

    if (props.currentPage >= 1 && props.currentPage <= 5) {
      if (props.currentPage >= 2 && props.currentPage <= 5) {
        pagesArr.push(4)
      }
      if (props.currentPage >= 3 && props.currentPage <= 5) {
        pagesArr.push(5)
      }
      if (props.currentPage === 5) {
        pagesArr.push(6)
      }

      pagesArr.push('...')
    }
    if (props.currentPage > 5 && props.currentPage < pagesNumbers.value - 3) {
      pagesArr.push('...')

      for (let page = beforePages; page <= afterPages; page++) {
        pagesArr.push(page)
      }
      if (props.currentPage !== pagesNumbers.value - 4) {
        pagesArr.push('...')
      }
    }

    if (props.currentPage >= pagesNumbers.value - 3) {
      pagesArr.push('...')
    }
    if (props.currentPage === pagesNumbers.value - 3) {
      pagesArr.push(props.currentPage - 1)
    }
    if (props.currentPage === pagesNumbers.value - 2) {
      pagesArr.push(props.currentPage - 1)
    }
    if (props.currentPage === pagesNumbers.value - 3) {
      pagesArr.push(props.currentPage)
    }

    pagesArr.push(...lastThreePages)

    return pagesArr
  } else {
    return pagesNumbers.value
  }
})

</script>
